package se.tada.preproc;

class ErrorDirective extends Unit
{
	public ErrorDirective(PreProcessor owner, String fileName, int startLine)
	{
		super(owner, fileName, startLine);
	}

	public void expand()
	throws ParseException
	{
		this.parseError("error: " + m_contents);
		super.expand();
	}

	public boolean isSignificant()
	{
		return m_contents != null;
	}

	public int parse(char[] buf, int bIdx)
	{
		// Scan until next nonescaped newline.
		//
		int start;
		int[] lcnt = new int[1];
		bIdx = skipWhite(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		start = bIdx;
		bIdx = skipToStartOfLine(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		if(m_owner.doingDependencyCheck())
			m_contents = null;
		else
			m_contents = String.valueOf(buf, start, (bIdx - 1) - start);
		return bIdx;
	}
}
