package se.tada.preproc;

import java.io.IOException;

class PragmaDirective extends Unit
{
	PragmaDirective(PreProcessor owner, String fileName, int startLine)
	{
		super(owner, fileName, startLine);
	}

	public void expand() throws ParseException
	{
		try
		{
			m_owner.write("#pragma ");
			m_owner.write(m_contents);
		}
		catch(IOException e)
		{
			throw new ParseException(e);
		}
	}

	public boolean isSignificant()
	{
		return m_contents != null;
	}

	public int parse(char[] buf, int bIdx)
	{
		// Scan until next nonescaped newline.
		//
		int start;
		int[] lcnt = new int[1];
		bIdx = skipWhite(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		start = bIdx;
		bIdx = skipToStartOfLine(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		if(m_owner.doingDependencyCheck())
			m_contents = null;
		else
			m_contents = String.valueOf(buf, start, bIdx - start);
		return bIdx;
	}
}