package se.tada.preproc;

class UndefDirective extends Unit
{
	public UndefDirective(PreProcessor owner, String fileName, int startLine)
	{
		super(owner, fileName, startLine);
	}

	public void expand() throws ParseException
	{
		m_owner.undefineMacro(this);
		super.expand();
	}

	public int parse(char[] buf, int bIdx)
	{
		int[] lcnt = new int[1];
		char c;

		bIdx = skipWhite(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		c = buf[bIdx];
		if(!(Character.isLetter(c) || c == '_'))
		{
			this.parseError("bad undef");
			bIdx = skipToStartOfLine(buf, bIdx, lcnt);
			m_lineCount += lcnt[0];
			return bIdx;
		}
		lcnt[0] = bIdx;
		m_contents = getIdentifier(buf, lcnt).intern();
		bIdx = lcnt[0];
		bIdx = skipToStartOfLine(buf, bIdx, lcnt);
		m_lineCount += lcnt[0];
		return bIdx;
	}

	public String name()
	{
		return m_contents;
	}
}
