/*
 * This file contains software that has been made available under The BSD
 * license. Use and distribution hereof are subject to the restrictions set
 * forth therein.
 * 
 * Copyright (c) 2004 TADA AB - Taby Sweden
 * All Rights Reserved
 */
package se.tada.util;

import java.io.File;

/**
 * @author Thomas Hallgren
 */

public class PathUtils
{
	public static File fileInPath(String path, String name)
	{
		return fileInPath(
			StringUtils.toArray(path, File.pathSeparator), name);
	}

	public static File fileInPath(String[] path, String name)
	{
		int top = (path == null) ? 0 : path.length;
		File file = new File(name);
		if(top == 0 || file.isAbsolute())
			//
			// No use prepending path's to an absolute
			// name.
			//
			return file.canRead() ? file : null;

		name = file.getPath();
		for(int idx = 0; idx < top; ++idx)
		{
			file = new File(path[idx], name);
			if(file.canRead())
				return file;
		}
		return null;
	}
}