package se.tada.util.eval;

import java.util.List;
import java.util.Map;

public class AtExpression extends BinaryExpression
{
	public AtExpression(Expression e1, Expression e2)
	{
		super(e1, e2);
	}

	public Object eval(Map ctx)
	throws EvalException
	{
		Object base = this.getLHS().eval(ctx);
		if(base == null)
			return null;

		Object key = this.getRHS().eval(ctx);

		if(base instanceof Map)
			return ((Map)base).get(key);

		if(key instanceof Number)
		{
			int idx = ((Number)key).intValue();
	
			if(base instanceof List)
				return ((List)base).get(idx);
	
			if(base instanceof Object[])
				return ((Object[])base)[idx];

			if(base instanceof String)
				return ((String)base).substring(idx, idx + 1);

			if(base instanceof int[])
				return new Integer(((int[])base)[idx]);

			if(base instanceof double[])
				return new Double(((double[])base)[idx]);

			if(base instanceof long[])
				return new Long(((long[])base)[idx]);

			if(base instanceof short[])
				return new Short(((short[])base)[idx]);

			if(base instanceof float[])
				return new Float(((float[])base)[idx]);

			if(base instanceof byte[])
				return new Byte(((byte[])base)[idx]);

			if(base instanceof char[])
				return new Character(((char[])base)[idx]);
		}
		throw new UnsupportedOperationException(base.getClass() + "[" + key.getClass() + "]");
	}
}