package se.tada.util.eval;

public abstract class BinaryExpression extends Expression
{
	private final Expression m_lhs;

	private final Expression m_rhs;

	public BinaryExpression(Expression lhs, Expression rhs)
	{
		m_lhs = lhs;
		m_rhs = rhs;
	}

	/**
	 * @return Returns the lhs.
	 */
	public final Expression getLHS()
	{
		return m_lhs;
	}

	/**
	 * @return Returns the rhs.
	 */
	public final Expression getRHS()
	{
		return m_rhs;
	}

	protected boolean isConstant()
	{
		return m_lhs.isConstant() && m_rhs.isConstant();
	}
}