package se.tada.util.eval;

public abstract class BinaryOp
{
	public Object execute(Object v1, Object v2)
	{
		if(v1 == null || v2 == null)
			return null;

		Object r = null;
		if(v1 instanceof Integer)
		{
			Integer i1 = (Integer)v1;
			if(v2 instanceof Integer)
				r = doIt(i1.intValue(), ((Number)v2).intValue());
			else if(v2 instanceof Double)
				r = doIt(i1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof String)
				r = doIt(i1.toString(), ((String)v2));
			else if(v2 instanceof Long)
				r = doIt(i1.longValue(), ((Number)v2).longValue());
			else if(v2 instanceof Short)
				r = doIt(i1.intValue(), ((Number)v2).intValue());
			else if(v2 instanceof Float)
				r = doIt(i1.floatValue(), ((Number)v2).floatValue());
			else if(v2 instanceof Byte)
				r = doIt(i1.intValue(), ((Number)v2).intValue());
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else if(v1 instanceof Double)
		{
			Double d1 = (Double)v1;
			if(v2 instanceof Number)
				r = doIt(d1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof String)
				r = doIt(d1.toString(), ((String)v2));
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else if(v1 instanceof String)
		{
			r = doIt((String)v1, v2.toString());
		}
		else if(v1 instanceof Long)
		{
			Long l1 = (Long)v1;
			if(v2 instanceof Double || v2 instanceof Float)
				r = doIt(l1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof Number)
				r = doIt(l1.longValue(), ((Number)v2).longValue());
			else if(v2 instanceof String)
				r = doIt(l1.toString(), ((String)v2));
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else if(v1 instanceof Short)
		{
			Short s1 = (Short)v1;
			if(v2 instanceof Short)
				r = doIt(s1.shortValue(), ((Number)v2).shortValue());
			else if(v2 instanceof Integer)
				r = doIt(s1.intValue(), ((Number)v2).intValue());
			else if(v2 instanceof Double)
				r = doIt(s1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof String)
				r = doIt(s1.toString(), ((String)v2));
			else if(v2 instanceof Long)
				r = doIt(s1.longValue(), ((Number)v2).longValue());
			else if(v2 instanceof Float)
				r = doIt(s1.floatValue(), ((Number)v2).floatValue());
			else if(v2 instanceof Byte)
				r = doIt(s1.shortValue(), ((Number)v2).shortValue());
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else if(v1 instanceof Float)
		{
			Float f1 = (Float)v1;
			if(v2 instanceof Double || v2 instanceof Long)
				r = doIt(f1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof Number)
				r = doIt(f1.floatValue(), ((Number)v2).floatValue());
			else if(v2 instanceof String)
				r = doIt(f1.toString(), ((String)v2));
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else if(v1 instanceof Byte)
		{
			Byte b1 = (Byte)v1;
			if(v2 instanceof Byte)
				r = doIt(b1.byteValue(), ((Number)v2).byteValue());
			else if(v2 instanceof Short)
				r = doIt(b1.shortValue(), ((Number)v2).shortValue());
			else if(v2 instanceof Integer)
				r = doIt(b1.intValue(), ((Number)v2).intValue());
			else if(v2 instanceof Double)
				r = doIt(b1.doubleValue(), ((Number)v2).doubleValue());
			else if(v2 instanceof String)
				r = doIt(b1.toString(), ((String)v2));
			else if(v2 instanceof Long)
				r = doIt(b1.longValue(), ((Number)v2).longValue());
			else if(v2 instanceof Float)
				r = doIt(b1.floatValue(), ((Number)v2).floatValue());
			else
				throw new UnsupportedOperationException(v2.getClass() + ":" + this.getClass());
		}
		else
			throw new UnsupportedOperationException(v1.getClass() + ":"
					+ this.getClass());

		return r;
	}

	protected abstract Object doIt(byte b1, byte b2);

	protected abstract Object doIt(short b1, short b2);

	protected abstract Object doIt(int b1, int b2);

	protected abstract Object doIt(long b1, long b2);

	protected abstract Object doIt(float b1, float b2);

	protected abstract Object doIt(double b1, double b2);

	protected abstract Object doIt(String b1, String b2);
}