package se.tada.util.eval;

import java.util.Map;

public class BinaryOpExpression extends BinaryExpression
{
	private final BinaryOp m_op;

	public BinaryOpExpression(BinaryOp op, Expression lhs, Expression rhs)
	{
		super(lhs, rhs);
		m_op = op;
	}

	public Object eval(Map ctx)
	throws EvalException
	{
		Object lhs = this.getLHS().eval(ctx);
		Object rhs = this.getLHS().eval(ctx);
		return m_op.execute(lhs, rhs);
	}
}