package se.tada.util.eval;

import java.util.Map;

public abstract class Expression
{
	public Expression resolveConstants()
	throws EvalException
	{
		return this.isConstant() ? this.resolve() : this;
	}

	public boolean isNull(Map ctx)
	throws EvalException
	{
		return this.eval(ctx) == null;
	}

	public boolean isTrue(Map ctx)
	throws EvalException
	{
		Object val = this.eval(ctx);
		return !(val == null || val.equals(Boolean.FALSE));
	}

	public abstract Object eval(Map ctx)
	throws EvalException;

	protected boolean isConstant()
	{
		return false;
	}

	protected Expression resolve()
	throws EvalException
	{
		return new Literal(this.eval(null));
	}
}