package se.tada.util.eval;

public abstract class UnaryOp
{
	public final Object execute(Object v)
	{
		Object r;
		if(v instanceof Integer)
			r = doIt(((Integer)v).intValue());
		else if(v instanceof Double)
			r = doIt(((Double)v).doubleValue());
		else if(v instanceof Long)
			r = doIt(((Long)v).longValue());
		else if(v instanceof Short)
			r = doIt(((Short)v).shortValue());
		else if(v instanceof Float)
			r = doIt(((Float)v).floatValue());
		else if(v instanceof Byte)
			r = doIt(((Byte)v).byteValue());
		else
			throw new UnsupportedOperationException(v.getClass() + ":" + this.getClass());
		return r;
	}

	protected abstract Object doIt(byte val);

	protected abstract Object doIt(short val);

	protected abstract Object doIt(int val);

	protected abstract Object doIt(long val);

	protected abstract Object doIt(float val);

	protected abstract Object doIt(double val);
}